"use strict";
/**
 * This function will find and update all the elements that matches the target value.
 * @param target the target value to be updated.
 * @param updateCriteria the callback function that will update the element
 * @returns undefined if no element was found or the updated elements
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.findAllByValueAndUpdate = void 0;
function findAllByValueAndUpdate(target, updateCriteria) {
    const udpatedElements = [];
    let tempTarget = target;
    let searchArray;
    if (typeof target === 'object') {
        tempTarget = JSON.stringify(target);
        searchArray = this.map(el => JSON.stringify(el));
    }
    else {
        searchArray = this;
    }
    for (let i = 0; i < this.length; i++) {
        if (tempTarget === searchArray[i]) {
            if (typeof target === 'object') {
                updateCriteria(this[i]);
            }
            else {
                this[i] = updateCriteria(this[i]);
            }
            udpatedElements.push(this[i]);
        }
    }
    return udpatedElements.length > 0 ? udpatedElements : undefined;
}
exports.findAllByValueAndUpdate = findAllByValueAndUpdate;
